/*************************************************
 *   Program: Konwertor z RTF -> HTML
 *   Autor: KoSiarz
 *   
 *   Data ostatniej modyfikacji: 21.06.2005 r.
 *   Kontakt: tajny
 *************************************************** 
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Specialized;

namespace richedit_sharp_test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{

		#region Pola klasy
		private System.Windows.Forms.Button bt_B;
		private System.Windows.Forms.Button bt_U;
		private System.Windows.Forms.Button bt_I;
		private System.Windows.Forms.Button bt_Font;
		private System.Windows.Forms.Button bt_Color;
		private System.Windows.Forms.Button bt_Konwersja;
		private System.Windows.Forms.RichTextBox zawartosc;
		private System.Windows.Forms.TextBox tb_Font;
		private System.Windows.Forms.ComboBox cb_rozmiar;
		private System.Windows.Forms.Button bt_wyczysc;
		private System.Windows.Forms.RichTextBox wynik_RTF;
		private System.Windows.Forms.RichTextBox wynik_HTML;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel suwak1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel suwak2;
		private System.Windows.Forms.Panel panel3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool suwak1_klik = false;
		private bool suwak2_klik = false;
		#endregion
		#region Konstruktor i dispose
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			bt_Color.BackColor = zawartosc.ForeColor;
			tb_Font.Text = zawartosc.Font.FontFamily.Name;
			int rozmiar = (int)zawartosc.Font.SizeInPoints;
			cb_rozmiar.SelectedItem = rozmiar.ToString();
			//cb_rozmiar = zawartosc.Font.SizeInPoints;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.zawartosc = new System.Windows.Forms.RichTextBox();
			this.bt_B = new System.Windows.Forms.Button();
			this.bt_U = new System.Windows.Forms.Button();
			this.bt_I = new System.Windows.Forms.Button();
			this.bt_Font = new System.Windows.Forms.Button();
			this.bt_Color = new System.Windows.Forms.Button();
			this.tb_Font = new System.Windows.Forms.TextBox();
			this.bt_Konwersja = new System.Windows.Forms.Button();
			this.wynik_RTF = new System.Windows.Forms.RichTextBox();
			this.cb_rozmiar = new System.Windows.Forms.ComboBox();
			this.bt_wyczysc = new System.Windows.Forms.Button();
			this.wynik_HTML = new System.Windows.Forms.RichTextBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.suwak1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.suwak2 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.panel3.SuspendLayout();
			this.SuspendLayout();
			// 
			// zawartosc
			// 
			this.zawartosc.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.zawartosc.Location = new System.Drawing.Point(8, 8);
			this.zawartosc.Name = "zawartosc";
			this.zawartosc.Size = new System.Drawing.Size(592, 80);
			this.zawartosc.TabIndex = 0;
			this.zawartosc.Text = "";
			// 
			// bt_B
			// 
			this.bt_B.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.bt_B.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_B.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.bt_B.Location = new System.Drawing.Point(8, 96);
			this.bt_B.Name = "bt_B";
			this.bt_B.Size = new System.Drawing.Size(24, 23);
			this.bt_B.TabIndex = 1;
			this.bt_B.Text = "B";
			this.bt_B.Click += new System.EventHandler(this.bt_B_Click);
			// 
			// bt_U
			// 
			this.bt_U.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.bt_U.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_U.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.bt_U.Location = new System.Drawing.Point(40, 96);
			this.bt_U.Name = "bt_U";
			this.bt_U.Size = new System.Drawing.Size(24, 23);
			this.bt_U.TabIndex = 2;
			this.bt_U.Text = "U";
			this.bt_U.Click += new System.EventHandler(this.bt_U_Click);
			// 
			// bt_I
			// 
			this.bt_I.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.bt_I.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_I.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.bt_I.Location = new System.Drawing.Point(72, 96);
			this.bt_I.Name = "bt_I";
			this.bt_I.Size = new System.Drawing.Size(24, 23);
			this.bt_I.TabIndex = 3;
			this.bt_I.Text = "I";
			this.bt_I.Click += new System.EventHandler(this.bt_I_Click);
			// 
			// bt_Font
			// 
			this.bt_Font.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.bt_Font.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_Font.Location = new System.Drawing.Point(8, 128);
			this.bt_Font.Name = "bt_Font";
			this.bt_Font.Size = new System.Drawing.Size(64, 23);
			this.bt_Font.TabIndex = 4;
			this.bt_Font.Text = "Font";
			this.bt_Font.Click += new System.EventHandler(this.bt_Font_Click);
			// 
			// bt_Color
			// 
			this.bt_Color.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.bt_Color.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_Color.Location = new System.Drawing.Point(104, 96);
			this.bt_Color.Name = "bt_Color";
			this.bt_Color.Size = new System.Drawing.Size(24, 23);
			this.bt_Color.TabIndex = 5;
			this.bt_Color.Click += new System.EventHandler(this.bt_Color_Click);
			// 
			// tb_Font
			// 
			this.tb_Font.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tb_Font.BackColor = System.Drawing.Color.Gainsboro;
			this.tb_Font.Location = new System.Drawing.Point(88, 128);
			this.tb_Font.Name = "tb_Font";
			this.tb_Font.ReadOnly = true;
			this.tb_Font.Size = new System.Drawing.Size(504, 20);
			this.tb_Font.TabIndex = 6;
			this.tb_Font.Text = "";
			// 
			// bt_Konwersja
			// 
			this.bt_Konwersja.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.bt_Konwersja.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_Konwersja.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.bt_Konwersja.Location = new System.Drawing.Point(512, 96);
			this.bt_Konwersja.Name = "bt_Konwersja";
			this.bt_Konwersja.TabIndex = 7;
			this.bt_Konwersja.Text = "Konwertuj";
			this.bt_Konwersja.Click += new System.EventHandler(this.bt_Konwersja_Click);
			// 
			// wynik_RTF
			// 
			this.wynik_RTF.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.wynik_RTF.Location = new System.Drawing.Point(8, 8);
			this.wynik_RTF.Name = "wynik_RTF";
			this.wynik_RTF.ReadOnly = true;
			this.wynik_RTF.Size = new System.Drawing.Size(592, 88);
			this.wynik_RTF.TabIndex = 8;
			this.wynik_RTF.Text = "";
			// 
			// cb_rozmiar
			// 
			this.cb_rozmiar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cb_rozmiar.Items.AddRange(new object[] {
															"6",
															"8",
															"9",
															"10",
															"12",
															"14",
															"16",
															"18",
															"20",
															"24"});
			this.cb_rozmiar.Location = new System.Drawing.Point(136, 96);
			this.cb_rozmiar.Name = "cb_rozmiar";
			this.cb_rozmiar.Size = new System.Drawing.Size(40, 21);
			this.cb_rozmiar.TabIndex = 10;
			this.cb_rozmiar.SelectedIndexChanged += new System.EventHandler(this.cb_rozmiar_SelectedIndexChanged);
			// 
			// bt_wyczysc
			// 
			this.bt_wyczysc.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.bt_wyczysc.BackColor = System.Drawing.Color.LightSkyBlue;
			this.bt_wyczysc.Location = new System.Drawing.Point(480, 96);
			this.bt_wyczysc.Name = "bt_wyczysc";
			this.bt_wyczysc.Size = new System.Drawing.Size(24, 23);
			this.bt_wyczysc.TabIndex = 11;
			this.bt_wyczysc.Text = "X";
			this.bt_wyczysc.Click += new System.EventHandler(this.bt_wyczysc_Click);
			// 
			// wynik_HTML
			// 
			this.wynik_HTML.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.wynik_HTML.Location = new System.Drawing.Point(8, 8);
			this.wynik_HTML.Name = "wynik_HTML";
			this.wynik_HTML.ReadOnly = true;
			this.wynik_HTML.Size = new System.Drawing.Size(592, 144);
			this.wynik_HTML.TabIndex = 12;
			this.wynik_HTML.Text = "";
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.panel1.Controls.Add(this.bt_B);
			this.panel1.Controls.Add(this.bt_Font);
			this.panel1.Controls.Add(this.cb_rozmiar);
			this.panel1.Controls.Add(this.bt_wyczysc);
			this.panel1.Controls.Add(this.zawartosc);
			this.panel1.Controls.Add(this.bt_Konwersja);
			this.panel1.Controls.Add(this.tb_Font);
			this.panel1.Controls.Add(this.bt_Color);
			this.panel1.Controls.Add(this.bt_I);
			this.panel1.Controls.Add(this.bt_U);
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(608, 160);
			this.panel1.TabIndex = 13;
			// 
			// suwak1
			// 
			this.suwak1.BackColor = System.Drawing.SystemColors.Highlight;
			this.suwak1.Cursor = System.Windows.Forms.Cursors.HSplit;
			this.suwak1.Location = new System.Drawing.Point(0, 160);
			this.suwak1.Name = "suwak1";
			this.suwak1.Size = new System.Drawing.Size(704, 8);
			this.suwak1.TabIndex = 14;
			this.suwak1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.suwak1_MouseUp);
			this.suwak1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.suwak1_MouseDown);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel2.BackColor = System.Drawing.SystemColors.Desktop;
			this.panel2.Controls.Add(this.wynik_RTF);
			this.panel2.Location = new System.Drawing.Point(0, 168);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(624, 104);
			this.panel2.TabIndex = 15;
			// 
			// suwak2
			// 
			this.suwak2.BackColor = System.Drawing.SystemColors.Info;
			this.suwak2.Cursor = System.Windows.Forms.Cursors.HSplit;
			this.suwak2.Location = new System.Drawing.Point(0, 272);
			this.suwak2.Name = "suwak2";
			this.suwak2.Size = new System.Drawing.Size(704, 8);
			this.suwak2.TabIndex = 16;
			this.suwak2.MouseUp += new System.Windows.Forms.MouseEventHandler(this.suwak2_MouseUp);
			this.suwak2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.suwak2_MouseDown);
			// 
			// panel3
			// 
			this.panel3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel3.BackColor = System.Drawing.SystemColors.Desktop;
			this.panel3.Controls.Add(this.wynik_HTML);
			this.panel3.Location = new System.Drawing.Point(0, 280);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(608, 160);
			this.panel3.TabIndex = 17;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Info;
			this.ClientSize = new System.Drawing.Size(608, 435);
			this.Controls.Add(this.panel3);
			this.Controls.Add(this.suwak2);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.suwak1);
			this.Controls.Add(this.panel1);
			this.MinimumSize = new System.Drawing.Size(320, 408);
			this.Name = "Form1";
			this.Text = "Konwerter by KoSiarz";
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}		
		#endregion

		private void bt_Konwersja_Click(object sender, System.EventArgs e)
		{
			wynik_RTF.Text = zawartosc.Rtf;
			if (zawartosc.Text == "")
			{
				wynik_HTML.Text = "<html>\n<head>\n</head>\n<body>\n</body>\n</html>";
				return;
			}

			int i;
			int dlugosc = zawartosc.Rtf.LastIndexOf('}');
			string html;							//wynikowy ciag html
			string tekst = zawartosc.Rtf;			//kopia tresci rtf (nie jest konieczna bo i tak jej nie modyfikujemy)
			string fraza;
			bool span = false;						//wskazuje czy wczytano nowy span
			bool span_open = false;					//wskazuje czy jest otwarty jakis span

			ArrayList czcionki = new ArrayList();	//tablica dostepnych krojow czcionek
			ArrayList kolory = new ArrayList();		//tablica dostepnych kolorow czcionek
			kolory.Add ("rgb(0,0,0) ");				//domyslny kolor

			int index1;
			int index2;
			int tmp_index1;
			int tmp_index2;

			bool bold = false;		//czy aktualna czcionka ma bolda
			bool italic = false;	//czy aktualna czcionka ma italic
			bool underline = false;	//czy aktualna czcionka ma podkreslenie
			int size = 0;			//wysokosc aktalnej czcionki
			int nrCzcionki = 0;		//nr aktualnego koloru czcionki w tablicy
			int nrKoloru = 0;		//nr aktualnego kroju czcionki w tablicy

			index1 = tekst.IndexOf(' ') + 1;			//pierwsza spacja jest zawsze przed nazwa domyslnej czcionki
			index2 = tekst.IndexOf(";}", index1);		//nazwa domyslnej czionki konczy sie ";}"

			czcionki.Add( "'" + tekst.Substring(index1, index2-index1) + "'"); //wczytanie domyslnej czcionki
			html = "<html>\n<head>\n</head>\n<body>\n<span style=\"font-family: "+ czcionki[0] +", sans-serif;\">\n";

			//wczytanie tablicy wszystkich dostepnych krojow czcionek
			tmp_index2 = tekst.IndexOf(";}}", index1);
			if ( tmp_index2 != index2)
			{
				do
				{
					index1 = tekst.IndexOf("{\\f", index2);
					if ( index1 == -1 || index1 > tmp_index2 ) break;
					index1 = tekst.IndexOf(" ", index1);
					index2 = tekst.IndexOf(";}", index1);
					czcionki.Add("'" + tekst.Substring(index1, index2 - index1) + "'");	
				} 
				while (index2 != tmp_index2);
			}

			//wczytanie tablicy dostepnych kolorow czcionek
			index1 = tekst.IndexOf("{\\colortbl", index2);
			if ( index1 != -1 )
			{
				index1 += 11;
				index2 = tekst.IndexOf(";}", index1);
				for (i = index1; i < index2; i++)
				{
					tmp_index1 = tekst.IndexOf("\\red", i) + 4;
					tmp_index2 = tekst.IndexOf("\\green", tmp_index1);
					fraza = "rgb(" + tekst.Substring(tmp_index1, tmp_index2 - tmp_index1) + ",";

					tmp_index1 = tmp_index2 + 6;
					tmp_index2 = tekst.IndexOf("\\blue", tmp_index1);
					fraza += tekst.Substring(tmp_index1, tmp_index2 - tmp_index1) + ",";

					tmp_index1 = tmp_index2 + 5;
					tmp_index2 = tekst.IndexOf(";\\red", tmp_index1);
					if ( tmp_index2 == -1 ) tmp_index2 = tekst.IndexOf(";}", tmp_index1);
					fraza += tekst.Substring(tmp_index1, tmp_index2 - tmp_index1) + ") ";

					kolory.Add(fraza);
					i = tmp_index2;
				}
			}

			index1 = tekst.IndexOf("\\pard") + 5;		//od tego zaczyna sie wiadomosc
			index2 = tekst.IndexOf("\\par", index1);	//linia zawsze konczy sie tym znakiem

			//analizujemy cala wiadomosc, 'i' oznacza aktualnie analizowana litere w tekscie
			for (i = index1; i < dlugosc; i++)
			{
				if (tekst[i] == '\\' && tekst[i + 1] != '\\')	//jesli w tekscie jest pojedynczy znak '\' to oznacza ze dalszy tekst tyczy sie formatowania tekstu
				{	//wczytujemy formatowanie

					index1 = i;

					//index2 okresli nam kiedy konczy sie wiadomosc o formatowaniu
					index2 = tekst.IndexOf(' ', index1, index2 - i);				//wtedy gdy za foramtowaniem jest tekst
					if ( index2 == -1 ) index2 = tekst.IndexOf("\\\\", index1) - 1;	//wtedy gdy za formatowaniem jest tekst ropoczynajacy sie znakiem '\'
					if ( index2 < 0 ) index2 = tekst.IndexOf("\\par", index1);		//za formatowaniem juz nic nie ma, jest tylko przejscie do nowej lini

					tmp_index1 = tmp_index2 = 0;

					//analizu tekstu formatujacego
					for (i = index1; i <= index2 ; i++)
					{

						if (tekst[i] == '\\' || i == index2) //jesli jest spelniony oznacza ze bedzie nowy argument formatowania, wiec zapamietujemy wkaznik na poczatek argumentu
						{
							if (tmp_index1 == 0) { tmp_index1 = i + 1; ++i; }
							else 
							{
								if (tmp_index2 == 0) tmp_index2 = i;
								fraza = tekst.Substring(tmp_index1, tmp_index2 - tmp_index1);

								//sprawdzamy wszystkie argumenty formatujace
								if (fraza == "ul")
								{
									underline = true;
								}
								else if (fraza == "ulnone")
								{
									underline = false;
								}
								else if (fraza == "b")
								{
									if (tmp_index2 == i) bold = true;
									else bold = false;
								}
								else if (fraza == "i")
								{
									if (tmp_index2 == i) italic = true;
									else italic = false;
								}
								else if (fraza == "f")
								{
									nrCzcionki = Convert.ToInt32(tekst.Substring(tmp_index2, i - tmp_index2));
								}
								else if (fraza == "fs")
								{
									size = Convert.ToInt32(tekst.Substring(tmp_index2, i - tmp_index2));
								}
								else if (fraza == "cf")
								{
									nrKoloru = Convert.ToInt32(tekst.Substring(tmp_index2, i - tmp_index2));
								}

								tmp_index2 = 0;
								tmp_index1 = i+1;
								++i;
							}
						}
						else if (tekst[i] >= '0' && tekst[i] <= '9')	//jesli prawda to znaczy ze argument ma jakis parametr, wiec zachowujemy skaznik na niego
						{
							if (tmp_index2 == 0) tmp_index2 = i;
						}
						
					}

					if ( span ) { html += "</span>\n"; span_open = false; } //bardzo mozliwe ze ta linijka jest niepotrzebna

					i = index2;
					index2 = tekst.IndexOf("\\par", index1);
					span = true;	//oznaczamy ze wystapila zmiana sposobu formatowania
					if ( i != index2 ) continue;
				}

				//ta czesc analizuje nam tresc (nie formatowanie ktore bylo analizowane wyzej)
				index1 = i;		//zapamietujemy wskaznik na poczatek napisu
				for (i = i; i <= index2; i++)	//szukamy konca napisu
				{
					if ( tekst[i] == '\\' )
					{
						if ( tekst[i + 1] != '\\' ) break;		//koniec napisu jest wtedy gdy wystapi znak '\' ale nie gdy wystapia dwa po sobie '\\'
						else ++i;
					}
				}				

				if ( span ) //jesli zmienilo sie formatowanie to trzeba je zapisac przed podaniem tekstu
				{
					if ( span_open ) fraza = "</span>\n<span style=\"font: "; //jesli bylo otwarte jakies formatowanie to nalezy je zamknac
					else fraza = "<span style=\"font: ";

					if ( italic ) fraza += " italic ";
					if ( bold ) fraza += " bold ";
					if ( !italic && !bold ) fraza += " normal ";
					fraza += " " + size + "px ";
					fraza += " " + czcionki[nrCzcionki] + "; ";

					if ( underline ) fraza += " text-decoration: underline; ";
					else fraza += " text-decoration: none; ";

					fraza += " color: " + kolory[nrKoloru] + ";\">";

					html += fraza;
					span = false;
					span_open = true;
				}
				html += tekst.Substring(index1, i - index1).Replace("\\\\","\\");	//zapisujemy tekst do htmla jednoczesnie zamieniejac wszystkie '\\' na '\'

				if ( i != index2 ) //jesli spelnoine to nie dotarlismy jeszce do konca linijki wiec zaczynaja sie nowe argumenty formatowania
				{ 
					html += "</span>\n"; 
					span_open = false; 
					--i; 
					continue; 
				}
				else
				{
					if (dlugosc - index2 > 7) //jesli spelnione to jeszcze nie jest koniec calej wiadomosci
					{
						html += "<br />\n\n";
						i = index2 + 5;
						index2 = tekst.IndexOf("\\par", i + 1);						
					}
					else break;
				}
			}

			if ( span_open ) html += "</span>";
			html += "\n</span>\n</body>\n</html>";
			wynik_HTML.Text = html;
		}

		private void bt_wyczysc_Click(object sender, System.EventArgs e)
		{
			zawartosc.Clear();
			zawartosc.Focus();
		}


		#region Przyciski do czcionki
		private void bt_Color_Click(object sender, System.EventArgs e)
		{
			ColorDialog dl = new ColorDialog();

			// Keeps the user from selecting a custom color.
			dl.AllowFullOpen = false ;
			dl.ShowHelp = true ;
			dl.Color = bt_Color.BackColor ;

			if (dl.ShowDialog() == DialogResult.OK)
				bt_Color.BackColor =  dl.Color;

			zawartosc.SelectionColor = bt_Color.BackColor;

			zawartosc.Focus();
		}

		private void bt_B_Click(object sender, System.EventArgs e)
		{
			zawartosc.SelectionFont = 
				new Font (zawartosc.SelectionFont.FontFamily, zawartosc.SelectionFont.Size,
				zawartosc.SelectionFont.Style^FontStyle.Bold, zawartosc.SelectionFont.Unit,
				zawartosc.SelectionFont.GdiCharSet, zawartosc.SelectionFont.GdiVerticalFont);

			zawartosc.Focus();
		}

		private void bt_U_Click(object sender, System.EventArgs e)
		{
			zawartosc.SelectionFont = 
				new Font (zawartosc.SelectionFont.FontFamily, zawartosc.SelectionFont.Size,
				zawartosc.SelectionFont.Style^FontStyle.Underline, zawartosc.SelectionFont.Unit,
				zawartosc.SelectionFont.GdiCharSet, zawartosc.SelectionFont.GdiVerticalFont);

			zawartosc.Focus();
		}

		private void bt_I_Click(object sender, System.EventArgs e)
		{
			zawartosc.SelectionFont = 
				new Font (zawartosc.SelectionFont.FontFamily, zawartosc.SelectionFont.Size,
				zawartosc.SelectionFont.Style^FontStyle.Italic, zawartosc.SelectionFont.Unit,
				zawartosc.SelectionFont.GdiCharSet, zawartosc.SelectionFont.GdiVerticalFont);

			zawartosc.Focus();
		}

		private void cb_rozmiar_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			zawartosc.SelectionFont = 
				new Font (zawartosc.SelectionFont.FontFamily, Convert.ToInt32(cb_rozmiar.SelectedItem),
				zawartosc.SelectionFont.Style, zawartosc.SelectionFont.Unit,
				zawartosc.SelectionFont.GdiCharSet, zawartosc.SelectionFont.GdiVerticalFont);

			zawartosc.Focus();
		}

		private void bt_Font_Click(object sender, System.EventArgs e)
		{
			FontDialog dl = new FontDialog();

			dl.ShowColor = true;

			dl.Font = zawartosc.SelectionFont;
			dl.Color = zawartosc.SelectionColor;

			if(dl.ShowDialog() != DialogResult.Cancel )
			{
				zawartosc.SelectionFont = dl.Font ;
				zawartosc.SelectionColor = dl.Color;
			}

			tb_Font.Text = dl.Font.FontFamily.Name;

			zawartosc.Focus();
		}
		#endregion		
		#region Obsluga suwakow
		private void suwak1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			suwak1_klik = true;
		}

		private void suwak1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( suwak1_klik )
			{
				int y = e.Y;
				if (y > 0)
				{
					if (panel2.Height - y < 60)	y = panel2.Height - 60;

					panel2.Height -= y;
					panel2.Top += y;
					suwak1.Top += y;
					panel1.Height += y;					
				}
				else if (y < 0)
				{
					if (panel1.Height + y < 120) y = panel1.Height - 120;
					else y *= -1;
					
					suwak1.Top -= y;
					panel1.Height -= y;
					panel2.Top -= y;
					panel2.Height += y;
				}
				suwak1_klik = false;
			}			
		}

		private void suwak2_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			suwak2_klik = true;
		}

		private void suwak2_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( suwak2_klik )
			{
				int y = e.Y;
				if (y > 0)
				{
					if (panel3.Height - y < 60) y = panel3.Height - 60;

					panel3.Height -= y;
					panel3.Top += y;
					suwak2.Top += y;
					panel2.Height += y;					
				}
				else if (y < 0)
				{
					if (panel2.Height + y < 60) y = panel2.Height - 60;
					else y *= -1;

					suwak2.Top -= y;
					panel2.Height -= y;
					panel3.Top -= y;
					panel3.Height += y;
				}
				suwak2_klik = false;
			}	
		}
		#endregion
	}
}
